/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky,
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h. Restrictions in
 * GB_copyright.h. 
 *
 * map.c -- display sector map of current planet 
 */

#include "GB_copyright.h"
#define S_X (stdscr->_maxx - NAMESIZE)
#define S_Y (stdscr->_maxy - 1)
#define Midx ((S_X - NAMESIZE)/2.0)
#define Midy (S_Y /2.0)
#define DISP_DATA 1

#include <curses.h>
#include <stdio.h>

extern char    *index(), *malloc();
extern int	have_inv;

plot_surface(t)
	char           *t;
{
	reg int         x, y;
	int             stand, show;
	int             Maxx, Maxy;
	char           *u, *v;

	clear();

	u = t + 1;
	/* get planet name */

	v = index(u, ';');
	*v = 0;

	move(0, 9);
	printw("`%s'\n   ", u);

	u = v + 1;
	v = index(u, ';');
	*v = 0;
	Maxx = atoi(u);

	u = v + 1;
	v = index(u, ';');
	*v = 0;
	Maxy = atoi(u);

	u = v + 1;
	v = index(u, ';');
	*v = 0;
	show = atoi(u);

	for (x = 0; x < Maxx; x++)
		printw("%d", x / 10);

	printw("\n   ");

	for (x = 0; x < Maxx; x++)
		printw("%d", x % 10);

	printw("\n");

	u = v + 1;
	for (y = 0; y < Maxy; y++) {
		mvaddch(y + 3, 0, y / 10 + '0');
		addch(y % 10 + '0');
		for (x = 0; x < Maxx; x++) {

			if (*u == '0')
				stand = 0;
			else
				stand = 1;
			u++;
			if (stand * have_inv)
				standout();
			mvaddch(y + 3, x + 3, *u);
			if (stand * have_inv)
				standend();
			u++;
		}
	}
	move(Maxy + 4, 0);
	refresh();
}
