/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB.c, enroll.dat.
 * Restrictions in GB.c.
 * autoshoot() -- shoot <-> retaliate routine
 * Bombard() -- ship bombards planet
 */

#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "doturn.h"
#include "buffers.h"

int fire_toshdata;
int bomb_shdata, bomb_sectdata;

/* ship #shipno bombards planet, then alert whom it may concern.
 */
Bombard(ship, shipno, planet, r)
shiptype *ship;
int shipno;
planettype *planet;
racetype *r;
{
shiptype *s;
int x,y,x2= -1,y2,oldown,numdest=0,numdest2=0,found=0;
int i, stren, stren0, stren1, stren2, sh, numretal=0;
int ok;
float dist,tech;
boolean whocares;

  /* for telegramming */
  bzero((char *)Nuked, sizeof(Nuked));

/* check to see if PDNs are present */
ok = 1;
sh = planet->ships;
openshdata(&bomb_shdata);
while(sh && ok) {
getship(bomb_shdata, &s, sh);
ok = !(s->is_alive && s->type==OTYPE_PLANDEF && s->owner != ship->owner);
sh = s->nextship;
free(s);
}
close_file(bomb_shdata);
if(!ok) {
    sprintf(buf, "Bombardment of %s cancelled, PDNs are present.\n",
	    prin_ship_orbits(ship));
    if(!notify(ship->owner, buf))
	push_message(TELEG_PLAYER_AUTO, ship->owner, buf);
    return;
}

opensectdata(&bomb_sectdata);
  getsmap(bomb_sectdata, Smap, planet);
  close_file(bomb_sectdata);

 /* look for someone to bombard-check for war */
  Getxysect(planet,0,0,1);	/* reset */
  while (!found && Getxysect(planet,&x,&y,0)) {
	if (Sector(*planet,x,y).owner && Sector(*planet,x,y).owner!=ship->owner
	    && !Sector(*planet,x,y).is_wasted) {
	  if (isset(r->atwar, Sector(*planet,x,y).owner) ||
		  (ship->type==OTYPE_BERS && 
	          Sector(*planet,x,y).owner==ship->object.number))
		found=1;
	  else
		x2=x,y2=y;
	}
  }
  if (x2 != -1) {
	x = x2;		/* no one we're at war with; bomb someone else. */
	y = y2;
	found = 1;
  }

  if (found) {
	placetype from,to;
	int str;
    str = MIN(Shipdata[ship->type][ABIL_GUNS]*(100-ship->damage)/100., ship->destruct);
	/* save owner of destroyed sector */
    if (str) {
	bzero(Nuked, sizeof(Nuked));
    	oldown = Sector(*planet,x,y).owner;
    	ship->destruct -= str;
    	ship->mass -= str * MASS_DESTRUCT;
    	from.level = LEVEL_SHIP;
    	from.shipptr = ship;
    	from.shipno = shipno;
    	to.level = LEVEL_PLAN;
    	to.snum = ship->storbits;
    	to.pnum = ship->pnumorbits;
    	numdest = shoot(ship->owner, from, &to, ship->owner, (planettype *)NULL,
		   planet, x,y, str, &dist, ship->tech, telegram_buf,0);
	/* (0=dont get smap) */
	if(numdest < 0) numdest = 0;

      	/* tell the bombarding player about it.. */
    	sprintf(telegram_buf,"REPORT from ship #%d\n\n",shipno);
     	sprintf(buf,"%s #%d %s reports bombing of planet /%s/%s,\n",
 			Shipnames[ship->type], shipno, ship->name,
			Stars[ship->storbits]->name,
			Stars[ship->storbits]->pnames[ship->pnumorbits]);
	str_cat(telegram_buf, buf);
    	sprintf(buf,"sector %d,%d (owner %d).  %d sectors destroyed.\n",
			x, y, oldown, numdest);
	str_cat(telegram_buf, buf);
	notify(ship->owner, telegram_buf); 

     /* notify other player. */
    	sprintf(telegram_buf,"ALERT from planet /%s/%s\n\n",
			Stars[ship->storbits]->name,
			Stars[ship->storbits]->pnames[ship->pnumorbits]);
     	sprintf(buf,"%s #%d %s Bombarded sector %d,%d; %d sectors destroyed.\n"
 		,Shipnames[ship->type], shipno, ship->name, x, y, numdest);
	str_cat(telegram_buf, buf);
	for (i=1; i<=Num_races; i++)
	   if (Nuked[i-1] && i != ship->owner)
		notify(i, telegram_buf);


/* enemy planet retaliates along with defending forces */


	stren = 0;
	tech = 0.0;
	for (i=1; i<= Num_races; i++)
	  if (i!=ship->owner && planet->info[i-1].numsectsowned) {
		stren0 = 0;
		stren1 = 0;
		stren2 = 0;
		/* go through linked list of ships orbiting the planet */
		/* only add ships ordered to defend planet */
		/* averaging the tech */
		sh = planet->ships;

		while (sh) {

		  to.shipptr = ships[sh];
		  if (to.shipptr->owner==i && to.shipptr->protect.planet) {

		    stren0 = MIN(to.shipptr->destruct,
			Shipdata[to.shipptr->type][ABIL_GUNS]*(100-to.shipptr->damage)/100.);
		    tech += to.shipptr->tech;
		    numretal++;
		    stren1 += stren0;
		    to.shipptr->destruct -= stren0;
		    to.shipptr->mass -= stren0 * MASS_DESTRUCT;
		  }
		  sh = to.shipptr->nextship;
		}
/* add planet defense strength */

		stren2 = planet->info[i-1].destruct;
		if(stren2 > PLAN_FIRE_LIM)
			stren2 = PLAN_FIRE_LIM;
		planet->info[i-1].destruct -= stren2;

		if (stren2>0)
			numretal++;

		tech = 100.;
		stren += stren1;
		stren += stren2;
      	/* tell the involved players about it.. */


/* execute attack */

    	numdest2 = shoot(1, to, &from, i, planet, (planettype *)NULL,x,y,stren,
		&dist, tech/numretal, telegram_buf, 0);	/* (0=dont get smap) */

    	sprintf(telegram_buf,"REPORT: Ship #%d Bombardment.\n\n",shipno);
		if(stren1) {
	sprintf(buf,"Defending ships return fire, total strength %d \n",stren1);
		str_cat(telegram_buf, buf);
      }
	sprintf(buf,"Planet returns fire with strength %d \n",stren2);
		str_cat(telegram_buf, buf);
	sprintf(buf,"%d percent damage to Ship #%d \n",numdest,shipno);
		str_cat(telegram_buf, buf);

	for (i=1; i<=Num_races; i++)
	  if (Nuked[i-1])
    		notify(oldown, telegram_buf);

      }

    } else {
		/* no weapons! */
	if (!ship->notified) {
		ship->notified = 1;
		sprintf(telegram_buf, 
 		  "Bulletin\n\n %s #%d %s has no weapons to bombard with.\n",
 		   Shipnames[ship->type],shipno,ship->name);
		notify(ship->owner, telegram_buf);
	}
    }

	opensectdata(&bomb_sectdata);
    putsmap(bomb_sectdata, Smap, planet);
    close_file(bomb_sectdata);

  } else {
	 /* there were no sectors worth bombing. */
    if (!ship->notified) {
	ship->notified = 1;
     	sprintf(telegram_buf,"Report from %s #%d %s\n\n",
		Shipnames[ship->type], shipno,ship->name);
    	sprintf(buf,"Planet /%s/%s has been saturation bombed.\n",
		Stars[ship->storbits]->name,
		Stars[ship->storbits]->pnames[ship->pnumorbits]);
	str_cat(telegram_buf, buf);   
	notify(ship->owner, telegram_buf); 
    }
  }
  return numdest;

}
