/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *  cs.c -- change scope (directory)
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
int cs_racedata;

center(Playernum, APcount, argn, args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
placetype where;

  where = Getplace(Playernum,args[1],0);	/* do not ignore the fact that you've not
					explored the place */
  if (where.err) {
	sprintf(buf,"cs: bad scope.\n");
		notify(Playernum, buf);
	return;
  }

Dir[Playernum-1].lastx[1] = Stars[where.snum]->xpos;
Dir[Playernum-1].lasty[1] = Stars[where.snum]->ypos;

}

cs(Playernum, APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
 placetype where;
 planettype *planet;
 shiptype *s;
 int cs_shdata,cs_pdata;

free(Race);
openracedata(&cs_racedata);
getrace(cs_racedata, &Race, Playernum); 
close_file(cs_racedata);

if (argn==1) {
	/* chdir to def scope */
  Dir[Playernum-1].level = Race->deflevel;
  if ((Dir[Playernum-1].snum = Race->defsystem) >= Sdata.numstars)
	Dir[Playernum-1].snum = Sdata.numstars-1;
  if ((Dir[Playernum-1].pnum = Race->defplanetnum) >= Stars[Dir[Playernum-1].snum]->numplanets)
	Dir[Playernum-1].pnum = Stars[Dir[Playernum-1].snum]->numplanets-1;
  Dir[Playernum-1].shipno = 0;
  Dir[Playernum-1].lastx[0] = Dir[Playernum-1].lasty[0] = 0.0;
  Dir[Playernum-1].lastx[1] = Stars[Dir[Playernum-1].snum]->xpos;
 Dir[Playernum-1].lasty[1] = Stars[Dir[Playernum-1].snum]->ypos;

		sprintf(Dir[Playernum-1].prompt,"  ( [%02d] %s / %s )\n ",
			Stars[Dir[Playernum-1].snum]->AP[Playernum-1],
			Stars[Dir[Playernum-1].snum]->name,
			Stars[Dir[Playernum-1].snum]->pnames[Dir[Playernum-1].pnum]);

    return;
 } else if (argn==2) {
	/* chdir to specified scope */

  where = Getplace(Playernum,args[1],0);	/* do not ignore the fact that you've not
					explored the place */
  if (where.err) {
	sprintf(buf,"cs: bad scope.\n");
		notify(Playernum, buf);
	Dir[Playernum-1].lastx[0] = Dir[Playernum-1].lasty[0] = 0.0;
	return;
  }

	/* fix lastx, lasty coordinates */

  switch (Dir[Playernum-1].level) {

	case LEVEL_UNIV:
		Dir[Playernum-1].lastx[0] = Dir[Playernum-1].lasty[0] = 0.0;
		break;

	case LEVEL_STAR:
		if (where.level==LEVEL_UNIV) {
			Dir[Playernum-1].lastx[1] = Stars[Dir[Playernum-1].snum]->xpos;
			Dir[Playernum-1].lasty[1] = Stars[Dir[Playernum-1].snum]->ypos;
		} else
			Dir[Playernum-1].lastx[0] = Dir[Playernum-1].lasty[0] = 0.0;
		break;

	case LEVEL_PLAN:
		openpdata(&cs_pdata);
		getplanet(cs_pdata,&planet,Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
		close_file(cs_pdata);
		if (where.level==LEVEL_STAR && where.snum==Dir[Playernum-1].snum) {
			Dir[Playernum-1].lastx[0] = planet->xpos;
			Dir[Playernum-1].lasty[0] = planet->ypos;
		} else if (where.level==LEVEL_UNIV) {
			Dir[Playernum-1].lastx[1] = Stars[Dir[Playernum-1].snum]->xpos + planet->xpos;
			Dir[Playernum-1].lasty[1] = Stars[Dir[Playernum-1].snum]->ypos + planet->ypos;
		} else
			Dir[Playernum-1].lastx[0] = Dir[Playernum-1].lasty[0] = 0.0;
		free(planet);
		break;
	case LEVEL_SHIP:
		openshdata(&cs_shdata);
		getship(cs_shdata, &s, Dir[Playernum-1].shipno);
		close_file(cs_shdata);
		if (!s->is_docked) {
		 switch (where.level) {
		   case LEVEL_UNIV:
			Dir[Playernum-1].lastx[1] = s->xpos;
			Dir[Playernum-1].lasty[1] = s->ypos;
			break;
		   case LEVEL_STAR:
			if (s->whatorbits>=LEVEL_STAR && s->storbits==where.snum) {
				/* we are going UP from the ship.. change last*/
				Dir[Playernum-1].lastx[0] = s->xpos - Stars[s->storbits]->xpos;
				Dir[Playernum-1].lasty[0] = s->ypos - Stars[s->storbits]->ypos;
			} else
				Dir[Playernum-1].lastx[0] = Dir[Playernum-1].lasty[0] = 0.0;
			break;
		   case LEVEL_PLAN:
			if (s->whatorbits==LEVEL_PLAN && s->storbits==where.snum
				   && s->pnumorbits==where.pnum) {
				/* same */
				openpdata(&cs_pdata);
				getplanet(cs_pdata,&planet,Stars[s->storbits]->planetpos[s->pnumorbits]);
				close_file(cs_pdata);
				Dir[Playernum-1].lastx[0] = s->xpos - Stars[s->storbits]->xpos - planet->xpos;
				Dir[Playernum-1].lasty[0] = s->ypos - Stars[s->storbits]->ypos - planet->ypos;
				free(planet);
			} else
				Dir[Playernum-1].lastx[0] = Dir[Playernum-1].lasty[0] = 0.0;
			break;
		   case LEVEL_SHIP:
			Dir[Playernum-1].lastx[0] = Dir[Playernum-1].lasty[0] = 0.0;
			break;
		   default:
			break;
		 }
		} else
			Dir[Playernum-1].lastx[0] = Dir[Playernum-1].lasty[0] = 0.0;
		free(s);
		break;
	default:
		break;
  }

  Dir[Playernum-1].level = where.level;
  Dir[Playernum-1].snum = where.snum;
  Dir[Playernum-1].pnum = where.pnum;
  Dir[Playernum-1].shipno = where.shipno;

   /* fix prompt */
      switch (Dir[Playernum-1].level) {
    	case LEVEL_UNIV:
		sprintf(Dir[Playernum-1].prompt," ( [%02d] / )\n ",Sdata.AP[Playernum-1]);
		break;
    	case LEVEL_STAR:
  		sprintf(Dir[Playernum-1].prompt,"  ( [%02d] %s )\n",
			Stars[Dir[Playernum-1].snum]->AP[Playernum-1],
			Stars[Dir[Playernum-1].snum]->name);
		break;
	case LEVEL_SHIP:
		switch (where.shipptr->whatorbits) { 	/* what orbits around */
		    case LEVEL_UNIV:
			sprintf(Dir[Playernum-1].prompt," ( [%02d] / #%d )\n ",
				Stars[Dir[Playernum-1].snum]->AP[Playernum-1],
				where.shipno);
			break;
    		    case LEVEL_STAR:
  			sprintf(Dir[Playernum-1].prompt,"  ( [%02d] %s / #%d )\n ",
				Stars[Dir[Playernum-1].snum]->AP[Playernum-1],
				Stars[Dir[Playernum-1].snum]->name,
				where.shipno);
			break;
		    case LEVEL_PLAN:
			sprintf(Dir[Playernum-1].prompt,"  ( [%02d] %s / %s / #%d )\n ",
				Stars[Dir[Playernum-1].snum]->AP[Playernum-1],
				Stars[Dir[Playernum-1].snum]->name,
				Stars[Dir[Playernum-1].snum]->pnames[Dir[Playernum-1].pnum],
				where.shipno);
			break;
		}
		free(where.shipptr);
		break;
	case LEVEL_PLAN:
		sprintf(Dir[Playernum-1].prompt,"  ( [%02d] %s / %s )\n ",
			Stars[Dir[Playernum-1].snum]->AP[Playernum-1],
			Stars[Dir[Playernum-1].snum]->name,
			Stars[Dir[Playernum-1].snum]->pnames[Dir[Playernum-1].pnum]);
		break;
	default: break;
      }

 } else if (argn==3 && args[1][1]=='d') {
	/* make new def scope */
  where = Getplace(Playernum,args[2],0);
  if (!where.err) {
	Race->deflevel = where.level;
	Race->defsystem = where.snum;
	Race->defplanetnum = where.pnum;
openracedata(&cs_racedata);
    putrace(cs_racedata, Race);
close_file(cs_racedata);

	sprintf(buf,"New home system is %s\n",Dispplace(Playernum, &where));
  } else {
	sprintf(buf,"cs: bad home system.\n");
	return;
  }
 }
}
