/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 * doturn -- does one turn.  
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "doturn.h"
#include "power.h"
#include "buffers.h"
#include <math.h>
int doturn_racedata;

do_turn()
{
 int star,i,j,fd, x, y;
 int shdata,stardata,pdata,sectdata;
 boolean err=0;
 shiptype *ship;
 sectortype *p;
 char t_buf[200];
int dummy;

 		/* make all 0 for first iteration of doplanet */
 bzero((char *)starpopns, sizeof(starpopns));
 bzero((char *)starnumships, sizeof(starnumships));
 bzero((char *)Sdatanumships, sizeof(Sdatanumships));
 bzero((char *)Stinfo, sizeof(Stinfo));
 bzero((char *)StarsInhab, sizeof(StarsInhab));
 bzero((char *)Power, sizeof(Power));

openshdata(&shdata);
Num_ships = Numships(shdata);
printf("Num ships = %d\n", Num_ships);

 ships = (shiptype **)malloc(sizeof(shiptype *) * (Num_ships + 1));

for(i=1; i<=Num_ships;i++)
	getship(shdata,&ships[i], i);	

close_file(shdata);  

/* get all stars and planets */
 openstardata(&stardata);
 getsdata(stardata,&Sdata);
 openpdata(&pdata);
 for (star=0; star<Sdata.numstars; star++) {
	free(Stars[star]);
 	getstar(stardata, &Stars[star], star);
	fix_stability(Stars[star]);		 /* nova */
 	for (i=0; i<Stars[star]->numplanets; i++) {
	    free(planets[star][i]);
	    getplanet(pdata,&planets[star][i],Stars[star]->planetpos[i]);
		/* move planets in orbit; also sets StarsInhab[] */
	   moveplanet(star, planets[star][i], i);
	if(Stars[star]->pnames[i]=='\0')
		sprintf(Stars[star]->pnames[i], "NULL-%d", i);
	}
	if(Stars[star]->name[0]=='\0')
		sprintf(Stars[star]->name, "NULL-%d", star);

	putstar(stardata, Stars[star], star);
} 
close_file(stardata);
close_file(pdata);

/*printf("doing VN_brain\n");*/
VN_brain.Most_mad = 0;	/* not mad at anyone for starts */

openracedata(&doturn_racedata);
Num_races = Numraces();
printf("Num_races = %d\n",Num_races);

for (i=1; i<=Num_races; i++) {

	getrace(doturn_racedata, &(races[i-1]),i);
		/* increase tech; change to something else */
	  races[i-1]->tech += (float)races[i-1]->IQ / 100.0;

		/* add VN program */
	VN_brain.Total_mad += Sdata.VN_hitlist[i-1];
		/* find out who they're most mad at */
	if (Sdata.VN_hitlist[VN_brain.Most_mad-1] <= Sdata.VN_hitlist[i-1])
		VN_brain.Most_mad = i;

}
	close_file(doturn_racedata);



	/* do all ships one turn */
        for (i=1; i<=Num_ships; i++) {
/*	    printf("ship %d\n",i);*/
	    doship(i,ships[i]);
      }
/* erase next ship pointers - reset in insert_sh_... */
	for (i=1; i<Num_ships;i++) 
	  ships[i]->nextship=0;

	/* clear ship list for insertion */
 Sdata.ships = 0;
 for (star=0; star<Sdata.numstars; star++) {
	Stars[star]->ships = 0;
 	for (i=0; i<Stars[star]->numplanets; i++) {
	   planets[star][i]->ships = 0;
	}
 }

     /* insert ship into the list of wherever it might be */
 openshdata(&shdata);
 for (i=Num_ships; i>=1; i--) {
    if(ships[i]->is_alive && !(ships[i]->type == STYPE_FIGHTER &&
		ships[i]->object.number4) ) {
	switch(ships[i]->whatorbits) {
	  case LEVEL_UNIV:
		insert_sh_univ(&Sdata, ships[i], i);
		break;
	  case LEVEL_STAR:
		insert_sh_star(Stars[ships[i]->storbits], ships[i],i);
		break;
	  case LEVEL_PLAN:
		insert_sh_plan(planets[ships[i]->storbits][ships[i]->pnumorbits], ships[i],i);
		break;
	  default:
		break;
	}
    }
    putship(shdata,ships[i],i);
 }
 close_file(shdata);



  /* add APs to sdata for ea. player */
  for (i=1; i<=Num_races; i++) { 
    int a;
    if ( (a = Sdata.AP[i-1] + APadd((int)Sdatanumships[i-1], (int)Sdatapopns[i],races[i-1]) + 1) > LIMIT_APs)
	Sdata.AP[i-1] = LIMIT_APs;
    else
	Sdata.AP[i-1] = a;
 }
 

 for (star=0; star<Sdata.numstars; star++) {

  for (i=0; i<Stars[star]->numplanets; i++) { 
/*	printf("%s %d\n",Stars[star]->name,i); */
    if (doplanet(star, planets[star][i], i)) {
	 /* save smap gotten & altered by doplanet only if the planet is expl*/
        opensectdata(&sectdata);
        putsmap(sectdata,Smap,planets[star][i]);
        close_file(sectdata);
    }

openpdata(&pdata);
    putplanet(pdata,planets[star][i],Stars[star]->planetpos[i]);
close_file(pdata);
  }

	   /* do AP's for ea. player  */
  for (i=1; i<=Num_races; i++) {
     if (isset(Stars[star]->explored, i) ) {
	 if ((j = Stars[star]->AP[i-1] + APadd((int)starnumships[star][i-1], (int)starpopns[star][i-1], races[i-1]) + 1) > LIMIT_APs)
         	Stars[star]->AP[i-1] = LIMIT_APs;
	 else
		Stars[star]->AP[i-1] = j;
       }

       if (starpopns[star][i-1])
	   setbit(Stars[star]->inhabited,i);
       else
	   clrbit(Stars[star]->inhabited,i);
   }
  openstardata(&stardata);
  putstar(stardata, Stars[star], star);
  close_file(stardata);
}

openstardata(&stardata);
 putsdata(stardata,&Sdata);
 close_file(stardata);


 openshdata(&shdata);
 for (i=1; i<=Num_ships; i++)
	putship(shdata,ships[i],i);

 close_file(shdata);


openracedata(&doturn_racedata); 
for (i=1; i<=Num_races; i++) {
	putrace(doturn_racedata, races[i-1]);
	free(races[i-1]);
    }
	close_file(doturn_racedata);

free(ships);

Putpower(Power);

/* compute alliance block power */
 for (i=1; i<=Num_races; i++) {
	dummy=(Blocks[i-1].invite & Blocks[i-1].pledge);
			if(isset(dummy, j)){
				Power_blocks.members[i-1] = 0;
				Power_blocks.sectors_owned[i-1] = 0;
				Power_blocks.popn[i-1] = 0;
				Power_blocks.ships_owned[i-1] = 0;
				Power_blocks.planets_owned[i-1] = 0;
				Power_blocks.resource[i-1] = 0;
				Power_blocks.fuel[i-1] = 0;
				Power_blocks.destruct[i-1] = 0;
				Power_blocks.VPs[i-1] = 0;
	for(j=1; j<=Num_races; j++) 
			if(isset(dummy, j)){
				Power_blocks.members[i-1] += 1;
				Power_blocks.sectors_owned[i-1] += Power[j-1].sectors_owned;
				Power_blocks.popn[i-1] += Power[j-1].popn;
				Power_blocks.ships_owned[i-1] += Power[j-1].ships_owned;
				Power_blocks.planets_owned[i-1] += Power[j-1].planets_owned;
				Power_blocks.resource[i-1] += Power[j-1].resource;
				Power_blocks.fuel[i-1] += Power[j-1].fuel;
				Power_blocks.destruct[i-1] += Power[j-1].destruct;
				Power_blocks.VPs[i-1] += Blocks[j-1].VPs;
			}
	}
}

 for (i=1; i<=Num_races; i++)
	notify(i, "Finished with update.\n");
	printf("Finished.\n");
}



 /* routine for number of AP's to add to each player in ea. system,scaled
    by amount of crew in their palace */

int APadd(sh, popn, race)
int sh, popn;
racetype *race;
{
 if (race->Gov_ship>0 && race->Gov_ship <= Num_ships &&
	ships[race->Gov_ship] != NULL &&
	ships[(int)(race->Gov_ship)]->is_alive &&
	ships[(int)(race->Gov_ship)]->is_docked &&
	ships[(int)(race->Gov_ship)]->whatdest==LEVEL_PLAN)
    return 
      round_rand( ((float)sh / 10.0 + (float)log10(1.0+popn))
	* ((float)ships[(int)(race->Gov_ship)]->popn/Shipdata[OTYPE_GOV][ABIL_MAXCREW])
	* .01 * (100.0 - (float)ships[(int)(race->Gov_ship)]->damage) );
 else
    return 0;
/* maybe we should give at least 1 AP? */
}



	/* fix stability for stars */
fix_stability(s)
startype *s;
{
char buf[100];
int a,i;


  if (s->nova_stage > 0) {
  	if (s->nova_stage > 14) {
		s->stability = 20;
		s->nova_stage = 0;
		sprintf(telegram_buf, "Notice\n");
		sprintf(buf,"\n  Scientists report that star %s\n", s->name);
			str_cat(telegram_buf, buf);
		sprintf(buf, "is no longer undergoing nova.\n");
			str_cat(telegram_buf, buf);
		for (i=1; i<=Num_races; i++)
			push_message(TELEG_PLAYER_AUTO, i, telegram_buf);

			/* telegram everyone when nova over? */
	} else
		s->nova_stage++;

  } else if (s->stability > 50) {
	a = int_rand(-1,3);
		/* nova just starting; notify everyone */
  	if ( (s->stability + a) > 100) {
		s->stability = 100;
		s->nova_stage = 1;
		sprintf(telegram_buf, "***** BULLETIN! ******\n");
		sprintf(buf,"\n  Scientists report that star %s\n", s->name);
			str_cat(telegram_buf, buf);
		sprintf(buf, "is undergoing nova.\n");
			str_cat(telegram_buf, buf);
		for (i=1; i<=Num_races; i++)
	push_message(TELEG_PLAYER_AUTO, i, telegram_buf);
	} else
		s->stability += a;
  } else
  	a = int_rand(-2,int_rand(0,int_rand(0,1) ) );
  	if ( (s->stability + a) < 0)
		s->stability = 0;
	else
		s->stability += a;
}



